package com.franckbarbier.Allowed_event_conflict;

public class Allowed_event_conflict {

    /**
     * UML states
     */
    private com.pauware.pauware_engine.Core.AbstractState _Any;
    private com.pauware.pauware_engine.Core.AbstractState _S1;
    private com.pauware.pauware_engine.Core.AbstractState _S11;
    private com.pauware.pauware_engine.Core.AbstractStateMachine _Allowed_event_conflict_state_machine;

    private void init_structure() throws com.pauware.pauware_engine.Exceptions.State_exception {
    }

    private void init_behavior() throws com.pauware.pauware_engine.Exceptions.State_exception {
        _Any = new com.pauware.pauware_engine.Core.State("Any");
        _S11 = new com.pauware.pauware_engine.Core.State("S11");
        _S1 = _S11.and(new com.pauware.pauware_engine.Core.State(com.pauware.pauware_engine.Core.AbstractState.Pseudo_state)).name("S1");
        _S1.inputState();
        _S1.allowedEvent("e", this, "g1", this, "a");
        _S11.allowedEvent("e", this, "g2", this, "b");
        _Allowed_event_conflict_state_machine = new com.pauware.pauware_engine.Core.StateMachine(_Any.xor(_S1), "Allowed event conflict", com.pauware.pauware_engine.Core.AbstractStateMachine.Show_on_system_out, new com.pauware.pauware2web.PauWare2Web_client());
    }

    public void start() throws com.pauware.pauware_engine.Exceptions.State_exception {
        _Allowed_event_conflict_state_machine.fires("e", _S1, _Any, this, "g3", this, "c");
        _Allowed_event_conflict_state_machine.fires("e", _S11, _Any, this, "g4", this, "d");
        _Allowed_event_conflict_state_machine.start();
    }

    public void stop() throws com.pauware.pauware_engine.Exceptions.State_exception {
        _Allowed_event_conflict_state_machine.stop();
    }

    public Allowed_event_conflict() throws com.pauware.pauware_engine.Exceptions.State_exception {
        init_structure();
        init_behavior();
    }

    /**
     * UML events
     */
    public void e() throws com.pauware.pauware_engine.Exceptions.State_exception {
        _Allowed_event_conflict_state_machine.run_to_completion("e");
    }

    /**
     * UML actions
     */
    public void a() {
        System.out.println("a executed...");
    }

    public void b() {
        System.out.println("b executed...");
    }

    public void c() {
        System.out.println("c executed...");
    }

    public void d() {
        System.out.println("d executed...");
    }

    /**
     * UML guards
     */
    // Please change the guards' returned values to understand the conflict management policy of PauWare engine:
    public boolean g1() {
        return true;
    }

    public boolean g2() {
        return true;
    }

    public boolean g3() {
        return true;
    }

    public boolean g4() {
        return true;
    }

    public static void main(String args[]) {
        try {
            Allowed_event_conflict aec = new Allowed_event_conflict();
            aec.start();
            aec.e();
            aec.stop();
        } catch (Throwable t) {
            t.printStackTrace();
        }
    }
}
